# This script is not really good. Normally, Predicate API must be
# used to aggregate different paths into a demand. Currently, this
# script can use only one path to create a demand. This is bad.

from Products.ERP5Type.DateUtils import addToDate

min_stock = context.getMinStock()
if not min_stock:
  return

to_date = addToDate(now, month=1) # FIX ME! check for 1 month so far

portal_type = context.getPortalType()

if portal_type.startswith('Purchase'):
  section_uid = context.getDestinationSectionUid()
  node_uid = context.getDestinationUid()

total_inventory = context.portal_simulation.getFutureInventory(
  at_date=now,
  resource_uid=context.getResourceUid(),
  section_uid=section_uid,
  node_uid=node_uid,
  #variation_text=None #NEED TO SUPPORT VARIATION
)

for brain in context.portal_simulation.getFutureInventoryList(
    from_date=now,
    to_date=to_date,
    section_uid=section_uid,
    node_uid=node_uid,
    resource_uid=context.getResourceUid(),
    #variation_text=None, #NEED TO SUPPORT VARIATION
    group_by_node=1,
    group_by_resource=1,
    group_by_variation=1,
    group_by_movement=1,
    sort_on=(('date', 'ASC'),),
):
  total_inventory += brain.inventory

required_amount = min_stock - total_inventory

if required_amount > 0:
  demand = context.purchase_demand_module.newContent(
    portal_type='Purchase Demand',
    start_date=now,
    specialise_value=context,
    variation_category_list=context.getVariationCategoryList(),
    source_section_value=context.getSourceSectionValue(),
    source_value=context.getSourceValue(),
    destination_section_value=context.getDestinationSectionValue(),
    destination_value=context.getDestinationValue(),
    resource_value=context.getResourceValue(),
    quantity=required_amount,
    quantity_unit_value=context.getQuantityUnitValue(),
    order_quantity_unit_value=context.getOrderQuantityUnitValue(),
    time_quantity_unit_value=context.getTimeQuantityUnitValue(),
    min_delay=context.getMinDelay(),
    max_delay=context.getMaxDelay(),
    min_flow=context.getMinFlow(),
    max_flow=context.getMaxFlow(),
    min_order_quantity=context.getMinOrderQuantity(),
    max_order_quantity=context.getMaxOrderQuantity(),
  )
  demand.autoPlan()
  return demand
