import random
from Products.ERP5Type.DateUtils import addToDate

base_date = DateTime('2017/1/1 00:00:00 GMT+9')



def create():

  quantity = random.randint(1, 100)
  product = context.product_module[str(random.randint(1, 10000))]
  brand = context.portal_categories.brand.objectValues()[random.randint(0, 99)].getId()
  customer = context.organisation_module[str(random.randint(4, 3000))]
  packing_form = random.choice(['case', 'package'])

  pl = context.sale_packing_list_module.newContent()
  org = context.organisation_module
  pl.edit(
  source_section_value=org['1'],
  source_value=org['2'],
  destination_section_value=customer,
  destination_value=customer,
  start_date=addToDate(base_date, day=random.randint(1, 364)),
  )
  line = pl.newContent(portal_type='Sale Packing List Line')
  line.edit(
  resource_value=product,
  quality='good',
  packing_form=packing_form,
  brand=brand,
  quantity=quantity)
  pl.confirm()
  pl.start()
  pl.stop()
  pl.deliver()

create()
